#ifdef __cplusplus
extern "C" {
#endif

#include  <stdio.h>
#include  <stdlib.h>
#include  <dos.h>
#include  <conio.h>
#include  <math.h>

#define   PCIFC16   0xB13017
#define   WORD	    unsigned short
#define   DWORD     unsigned long
#define   UCHAR     unsigned char

#define  MAX_BOARD_NUMBER 15

#define NoError 		      0
#define DriverHandleError	1
#define DriverCallError		2
#define FindBoardError		3
#define TimeOut 		      4
#define ExceedBoardNumber	5
#define NotFoundBoard		6
#define InvalidChannel		7
#define AIQueueError			8
#define FIFOError				9
#define InvalidEEPBlock		10
#define InvalidEEPAddr		11
#define InvlidCfgCode		12
#define InvlidModelNo		13
#define SetCfgCodeErr		14
#define InvildCardID			15

WORD   PCIFC16_DriverInit(WORD *wBoards);
WORD   PCIFC16_DriverClose(void);
WORD   PCIFC16_GetDriverVersion(WORD *wDriverVersion);
WORD   PCIFC16_GetConfigAddressSpace(WORD wBoardNo, DWORD *wBaseAddr0, DWORD *wBaseAddr1, DWORD *wBaseAddr2, DWORD *wBaseAddr3, WORD *wIrq, WORD *wModelID, WORD *wCardID);
WORD   PCIFC16_GetBoardNoByCardID(WORD *wBoardNo,WORD wCardID);
WORD   PCIFC16_SetDIOMode32(WORD wBoardNo,WORD wDirection);
WORD   PCIFC16_WriteDO(WORD wBoardNo,WORD wPortNo,WORD wValue);
WORD   PCIFC16_ReadDI(WORD wBoardNo,WORD wPortNo, WORD *wValue);
WORD   PCIFC16_SetChannelMode(WORD wBoardNo,WORD wChannel,WORD wMode,WORD wDelayMs);
WORD   PCIFC16_ReadFrequency(WORD wBoardNo,WORD wChannel,float *fValue,DWORD dwTimeOutMs,WORD *wStatus);
WORD   PCIFC16_ReadCounter(WORD wBoardNo,WORD wChannel,DWORD *dwValue);

#ifdef __cplusplus
}
#endif