/* demo 3 : Square Wave Generator			       */
/* step 1 : all CLK select clock1=8M			       */
/* step 2 : run DEMO3.EXE				       */
/* step 3 : check all Cout of four 8254 by scope	       */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"
#include "dos.H"

WORD pci_tmc12_select8254(char cChip);
WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh);
WORD wBaseAddr,wIrq;

WORD pci_tmc12_do(WORD wDo);

unsigned int check,v1,v2;
unsigned long err,ok;
int min,max,start,bug;

int main()
{
unsigned int  i,j,count,high,low;
WORD wBoards,wRetVal,wPLX;
char c;

clrscr();
show_time();
show_time();
show_time();

wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBaseAddr);

pci_tmc12_do2(0);
pci_tmc12_select8254(0);
pci_tmc12_c0(0x30,0xff,0xff);
pci_tmc12_c1(0x70,0xfe,0xff);
pci_tmc12_c2(0xb0,0xfd,0xff);

pci_tmc12_select8254(1);
pci_tmc12_c0(0x30,0xfc,0xff);
pci_tmc12_c1(0x70,0xfb,0xff);
pci_tmc12_c2(0xb0,0xfa,0xff);


pci_tmc12_select8254(2);
pci_tmc12_c0(0x30,0xf9,0xff);
pci_tmc12_c1(0x70,0xf8,0xff);
pci_tmc12_c2(0xb0,0xf7,0xff);

pci_tmc12_select8254(3);
pci_tmc12_c0(0x30,0xf6,0xff);
pci_tmc12_c1(0x70,0xf5,0xff);
pci_tmc12_c2(0xb0,0xf4,0xff);

ok=err=0; bug=0;

min=999; max=0; start=0;


    pci_tmc12_select8254(0);
    delay(100);
    pci_tmc12_do2(0);
    pci_tmc12_do2(0xffff);
    pci_tmc12_do2(0);
    pci_tmc12_do2(0xffff);


for (;;)
    {
    pci_tmc12_do2(0);
    pci_tmc12_do2(0x0fff);

    pci_tmc12_select8254(0);
    test_c1(1);
    test_c2(2);
    test_c3(3);

    pci_tmc12_select8254(1);
    test_c1(4);
    test_c2(5);
    test_c3(6);

    pci_tmc12_select8254(2);
    test_c1(7);
    test_c2(8);
    test_c3(9);

    pci_tmc12_select8254(3);
    test_c1(10);
    test_c2(11);
    test_c3(12);

    /*
    if (kbhit())
       {
       getch();
       return;
       }
    */
    printf("\n------------------------");
    c=getch();
    if ((c=='q') || (c=='Q')) return;
    }



for (;;)
    {

    pci_tmc12_select8254(0);
    delay(100);
    test_c1(1);
    test_c2(2);
    test_c3(3);



    pci_tmc12_select8254(1);
    delay(100);
    test_c1(4);
    test_c2(5);
    test_c3(6);



    pci_tmc12_select8254(2);
    delay(100);
    test_c1(7);
    test_c2(8);
    test_c3(9);




    pci_tmc12_select8254(3);
    delay(100);
    test_c1(10);
    test_c2(11);
    test_c3(12);


    printf("\n----------------------------------------");

    if (kbhit()!=0) {getch(); break;}

    start=1;
    }

PTMC12_DriverClose();
}

/* -------------------------------------------------------------------- */

test_c1(int B)
{
unsigned int  i,j,count,high,low,HH[10],LL[10],check,old_count;
char c;

i=0;
v1=0; v2=0; old_count=0; start=0;
/* for (;;) */
    {
    outp(wBaseAddr+0x0c,0);
    low=inp(wBaseAddr);
    high=inp(wBaseAddr);
    count=(0xff-high)*256+(0xff-low);
    printf("\nCNT_%2d high=%2x, low=%2x, count=%5u",B,high,low,count);
    }

}

/* -------------------------------------------------------------------- */

test_c2(int B)
{
unsigned int  i,j,count,high,low,HH[10],LL[10],check,old_count;
char c;

i=0;
v1=0; v2=0; old_count=0; start=0;
/* for (;;) */
    {
    outp(wBaseAddr+0x0c,0x40);
    low=inp(wBaseAddr+4);
    high=inp(wBaseAddr+4);
    count=(0xff-high)*256+(0xff-low);
    printf("\nCNT_%2d high=%2x, low=%2x, count=%5u",B,high,low,count);
    }

}

/* -------------------------------------------------------------------- */

test_c3(int B)
{
unsigned int  i,j,count,high,low,HH[10],LL[10],check,old_count;
char c;

i=0;
v1=0; v2=0; old_count=0; start=0;
/* for (;;) */
    {
    outp(wBaseAddr+0x0c,0x80);
    low=inp(wBaseAddr+8);
    high=inp(wBaseAddr+8);
    count=(0xff-high)*256+(0xff-low);
    printf("\nCNT_%2d high=%2x, low=%2x, count=%5u",B,high,low,count);
    }

}


/* -------------------------------------------------------------------- */

show_time()
{
struct time buf;

gettime(&buf);
printf(" , time=%d:%d:%d",buf.ti_hour,buf.ti_min,buf.ti_sec);
}

/* -------------------------------------------------------------------- */

WORD pci_tmc12_select8254(char cChip)
{
outp(wBaseAddr+0x10,cChip);
return(NoError);
}

WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh)
{
outp(wBaseAddr+0x0C,cConfig);
outp(wBaseAddr	   ,cLow);
outp(wBaseAddr	   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh)
{
outp(wBaseAddr+0x0C,cConfig);
outp(wBaseAddr+4   ,cLow);
outp(wBaseAddr+4   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh)
{
outp(wBaseAddr+0x0C,cConfig);
outp(wBaseAddr+8   ,cLow);
outp(wBaseAddr+8   ,cHigh);
return(NoError);
}

/* ----------------------------------------------------------- */

WORD pci_tmc12_do(WORD wDo)
{
outp(wBaseAddr+0x14,wDo);
return(NoError);
}

/* ----------------------------------------------------------- */

pci_tmc12_do2(WORD wDo)
{
outport(wBaseAddr+0x18,wDo);
return(NoError);
}

/* ----------------------------------------------------------- */

void pci_tmc12_di(WORD *wDi)
{
WORD wRetVal;
(*wDi)=(inport(wBaseAddr+0x14))&0xffff;
}

