/* The header file for PIO-D144 card */

#define Disable     0
#define Enable      1

#define D144        wBase+0x00

#define IO_SCR0     wBase+0xc8
#define IO_SCR1     wBase+0xcc
#define IO_SCR2     wBase+0xd0

#define AUX_CR      wBase+0x02
#define AUX_DR      wBase+0x03

#define INT_MCR     wBase+0x05

#define AUX_SR      wBase+0x07

#define INT_PCR     wBase+0x2a

#define RW_8BitDR   wBase+0xc0

#define Act_IOPCR   wBase+0xc4

#define CN1_PA      0
#define CN1_PB      1
#define CN1_PC      2

#define CN2_PA      3
#define CN2_PB      4
#define CN2_PC      5

#define CN3_PA      6
#define CN3_PB      7
#define CN3_PC      8

#define CN4_PA      9
#define CN4_PB      10
#define CN4_PC      11

#define CN5_PA      12
#define CN5_PB      13
#define CN5_PC      14

#define CN6_PA      15
#define CN6_PB      16
#define CN6_PC      17

#define A1_8259     0x20
#define A2_8259     0Xa0
#define EOI         0x20
