/* ----------------------------------------------------------- */
/* DEMO 1 : Digital I/O demo				       */
/* Compiler: Turbo C++ 3.0, Mode Large                         */
/* ----------------------------------------------------------- */

#include "PCIFC16.H"
#include <DOS.H>

DWORD dwBaseAddr,dwBaseDIO,dwBaseDA,dwBaseAD;
WORD wIrq,wModelID,wCardID;

void main()
{
  int  i;
  WORD wBoards;
  WORD wDIVal,wBoardNo,wRtn;
  WORD wSelectBoard;
  char c;

  clrscr();
  wRtn=PCIFC16_DriverInit(&wBoards);
  printf("\nThrer are %d PCI-FC16 Cards in this PC",wBoards);
  if ( wBoards==0 )
  {
	putch(0x07);  putch(0x07);  putch(0x07);
	printf("\nThere are no PCI-FC16 card in this PC !!!\n"); exit(0);
  }


  printf("\nShow the Configuration Space");
  printf("\n   Model BoardNo  BaseAddr     BaseDIO     BaseDA      BaseAD   IrqNo CardID");
  for(i=0; i<wBoards; i++)
  {
	wRtn = PCIFC16_GetConfigAddressSpace(0,&dwBaseAddr, &dwBaseDIO, &dwBaseDA, &dwBaseAD, &wIrq, &wModelID, &wCardID);
	if (wRtn) printf("\nGetCardInfo Error!!!");
	printf("\n PCI-%4x  %d",wModelID,i);
	printf("     0x%lx  0x%lx  0x%lx  0x%lx  0x%2x  0x%2x",dwBaseAddr,dwBaseDIO,dwBaseDA,dwBaseAD,wIrq,wCardID);
	}

  printf("\nPlease press any key.");
  getch();

  PCIFC16_DriverClose();
}

