/* DEMO 2 : PISO-P8R8 (PISO-P8SSR8AC/PISO-P8SSR8DC) DI/O demo     */
/* step 2 : Run DEMO1.EXE                                         */
/* Note   : Relay states will be show on LED                      */
/* -------------------------------------------------------------- */
#include "PIO.H"

WORD wBase,wIrq;

int main()
{
int  i,j;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5,t6;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;

clrscr();

/* step1 : find address-mapping of PIO/PISO cards                 */
wRetVal=PIO_DriverInit(&wBoards,0x80,0x08,0x30); /* for PISO-P8R8 */
printf("\n(1) Threr are %d PISO-P8R8 Cards in this PC",wBoards);
if ( wBoards==0 ) exit(0);

printf("\n\n-------------- The Configuration Space --------------");
for(i=0;i<wBoards;i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,&wSlotBus,&wSlotDevice);

   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);

   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

                                                 /* select card_0 */
PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

/* step2 : enable all D/I/O port                                  */
outportb(wBase,1);                                /* /RESET -> 1  */

i=1;
for (;;)
    {
    outportb(wBase+0xc0,i);
    delay(20000);
    j=(inportb(wBase+0xc0)&0xff);

    gotoxy(1,7);
    printf("Output=[%2x] => Input=[%2x]",i,j);
    if (j!=i)
       {
       printf(" <- Error");
       getch();
       }

    i=(i<<1)&0xff;
    if (i==0) i=1;

    if (kbhit()!=0) break;
    }

PIO_DriverClose();
}



