/* ndemo1 : LED1, LED2, LED3 demo			       */
/* step 1 : default shipping of PCI-TMC12A		       */
/* step 2 : run NDEMO1.EXE				       */
/* step 3 : the LED1/2/3 of TMC12A will turn on sequentially   */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"

WORD pci_tmc12_do(WORD wDo);
WORD pci_tmc12_do2(WORD wXor);
WORD wBaseAddr,wIrq,wPLX;

int main()
{
int  i,j;
WORD wBoards,wRetVal;
char c;

clrscr();
wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0 LED test, wBaseAddr=%x ***",wBaseAddr);

pci_tmc12_do2(0xe000); printf("\nAll LED off, press any key to continue"); getch();
pci_tmc12_do2(0xc000); printf("\nLED1 on,     press any key to continue"); getch();
pci_tmc12_do2(0xa000); printf("\nLED2 on,     press any key to continue"); getch();
pci_tmc12_do2(0x6000); printf("\nLED3 on,     press any key to continue"); getch();

PTMC12_DriverClose();
}

/* ----------------------------------------------------------- */

WORD pci_tmc12_do(WORD wDo)
{
outport(wBaseAddr+0x14,wDo);
return(NoError);
}

/* ----------------------------------------------------------- */

WORD pci_tmc12_do2(WORD wXor)
{
outport(wBaseAddr+0x18,wXor);
return(NoError);
}
