/* ------------------------------------------------------------- */
/* demo 10: Find card number				         */
/* step 1 : run demo10.exe				         */
/* step 2 : connect a 50-pin flat-cable to CON2 & CON3 of card_? */
/* step 3 : The card number is shown in screen as TEST OK        */
/* ------------------------------------------------------------- */

#include "PIO.H"

WORD wBase,wIrq;
WORD wBoards,wRetVal;
WORD wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;

int main()
{
int  i,j,k;

char c;

clrscr();
PIO_DriverInit(&wBoards,0x80,0x01,0x00);  /* for PIO-D144 */
printf("\n(1) Threr are %d PIO-D144 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PIO-D144 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) The Configuration Space ->   wBase");
for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]"
	   ,i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
    }

    PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);
for (;;)
    {
    printf("\n------------- press any key to stop -------------");
    for (i=0; i<wBoards; i++) test_card(i);
    delay_ms(1000); /* delay 1 sec */
    if (kbhit()!=0) {getch(); break;}
    }

PIO_DriverClose();
}

/* ----------------------------------------------------------- */

test_card(int card)
{
int i,j,k,ok,val;

PIO_GetConfigAddressSpace(card,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);

outp(wBase,1);	          /* enable D/I/O     */

ok=1;
outp(wBase+0xc8,0x00);    /* CN2_PA is output */
outp(wBase+0xcc,0x01);    /* CN3_PA is input  */

outp(wBase+0xc4,3);       /* select CN2_PA    */
outp(wBase+0xc0,0x55);    /* CN2_PA=0x55      */
outp(wBase+0xc4,6);       /* select CN2_PA    */
val=inp(wBase+0xc0)&0xff; /* read CN3_PA      */
if (val != 0x55) ok=0;

outp(wBase+0xc4,3);       /* select CN2_PA    */
outp(wBase+0xc0,0xAA);    /* CN2_PA=0xAA      */
outp(wBase+0xc4,6);       /* select CN3_PA    */
val=inp(wBase+0xc0)&0xff; /* read CN3_PA      */
if (val != 0xaa) ok=0;

printf("\nCard Number=%d, wBase=%x",card,wBase);
if (ok==1) printf(", Test OK"); else printf(", Test ERROR");
}

/* ----------------------------------------------------------- */

delay_ms(int t)
{
int i,j,k,l,m;

for (i=0; i<t; i++)
for (j=0; j<100; j++)
    {
    m=0;
    for (k=0; k<100; k++) {l=(j+t)*i; m+=l;}
    }
}
